# coding: utf-8

"""
    style-api

    This is a API document for Stylens Service

    OpenAPI spec version: 0.0.1
    Contact: master@bluehack.net
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class ProductApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def get_product_by_hostcode_and_product_no(self, host_code, product_no, **kwargs):
        """
        Get Product by hostCode and productNo
        Returns Product belongs to a Host and productNo
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_product_by_hostcode_and_product_no(host_code, product_no, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str host_code:  (required)
        :param str product_no:  (required)
        :return: GetProductResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_product_by_hostcode_and_product_no_with_http_info(host_code, product_no, **kwargs)
        else:
            (data) = self.get_product_by_hostcode_and_product_no_with_http_info(host_code, product_no, **kwargs)
            return data

    def get_product_by_hostcode_and_product_no_with_http_info(self, host_code, product_no, **kwargs):
        """
        Get Product by hostCode and productNo
        Returns Product belongs to a Host and productNo
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_product_by_hostcode_and_product_no_with_http_info(host_code, product_no, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str host_code:  (required)
        :param str product_no:  (required)
        :return: GetProductResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['host_code', 'product_no']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_product_by_hostcode_and_product_no" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'host_code' is set
        if ('host_code' not in params) or (params['host_code'] is None):
            raise ValueError("Missing the required parameter `host_code` when calling `get_product_by_hostcode_and_product_no`")
        # verify the required parameter 'product_no' is set
        if ('product_no' not in params) or (params['product_no'] is None):
            raise ValueError("Missing the required parameter `product_no` when calling `get_product_by_hostcode_and_product_no`")


        collection_formats = {}

        path_params = {}
        if 'host_code' in params:
            path_params['hostCode'] = params['host_code']
        if 'product_no' in params:
            path_params['productNo'] = params['product_no']

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/products/hosts/{hostCode}/products/{productNo}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='GetProductResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_products(self, **kwargs):
        """
        Query to search products
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_products(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param file file: Image file to upload (only support jpg format yet)
        :return: GetProductsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_products_with_http_info(**kwargs)
        else:
            (data) = self.get_products_with_http_info(**kwargs)
            return data

    def get_products_with_http_info(self, **kwargs):
        """
        Query to search products
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_products_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param file file: Image file to upload (only support jpg format yet)
        :return: GetProductsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['file']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_products" % key
                )
            params[key] = val
        del params['kwargs']


        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'file' in params:
            local_var_files['file'] = params['file']

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['multipart/form-data'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api('/products', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='GetProductsResponse',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
